=== scripts/Makefile ===
lint:
	python -m mypy *.py
