=== debian/changelog ===
simdutf (7.5.0-2) unstable; urgency=medium

  * Release to unstable

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 19 Oct 2025 14:11:57 -0400

simdutf (7.5.0-1) experimental; urgency=medium

  * New upstream release

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 18 Oct 2025 08:11:02 -0400
